Bug 853687 - Review Request: erlang-folsom - Erlang-based metrics system
Review Request: erlang-folsom - Erlang-based metrics system
Status: CLOSED NEXTRELEASE
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Mario Blättermann
Fedora Extras Quality Assurance
:
Depends On: 853686
Blocks: 849603 854547 854558
  Show dependency treegraph
 
Reported: 2012-09-02 02:44 EDT by Peter Lemenkov
Modified: 2012-10-19 10:23 EDT (History)
3 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2012-10-19 10:23:40 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
mario.blaettermann: fedora‑review+
tibbs: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Peter Lemenkov 2012-09-02 02:44:31 EDT
Spec URL: http://peter.fedorapeople.org/erlang-folsom.spec
SRPM URL: http://peter.fedorapeople.org/erlang-folsom-0.7.1-1.fc19.src.rpm
Description: Folsom is an Erlang based metrics system inspired by Coda Hale's metrics. 
The metrics API's purpose is to collect realtime metrics from your Erlang
applications and publish them via Erlang APIs and output plugins. Folsom is not
a persistent store. There are 6 types of metrics: counters, gauges, histograms
and timers, histories, meter_readers and meters. Metrics can be created, read
and updated via the folsom_metrics module.
Fedora Account System Username: peter
Comment 1 Mario Blättermann 2012-10-07 10:29:59 EDT
Scratch build:
http://koji.fedoraproject.org/koji/taskinfo?taskID=4568538

$ rpmlint -i -v *
erlang-folsom.i686: I: checking
erlang-folsom.i686: W: spelling-error %description -l en_US realtime -> mealtime, real time, real-time
The value of this tag appears to be misspelled. Please double-check.

erlang-folsom.i686: I: checking-url https://github.com/boundary/folsom (timeout 10 seconds)
erlang-folsom.i686: E: no-binary
The package should be of the noarch architecture because it doesn't contain
any binaries.

erlang-folsom.i686: W: only-non-binary-in-usr-lib
There are only non binary files in /usr/lib so they should be in /usr/share.

erlang-folsom.x86_64: I: checking
erlang-folsom.x86_64: W: spelling-error %description -l en_US realtime -> mealtime, real time, real-time
The value of this tag appears to be misspelled. Please double-check.

erlang-folsom.x86_64: I: checking-url https://github.com/boundary/folsom (timeout 10 seconds)
erlang-folsom.x86_64: E: no-binary
The package should be of the noarch architecture because it doesn't contain
any binaries.

erlang-folsom.x86_64: W: only-non-binary-in-usr-lib
There are only non binary files in /usr/lib so they should be in /usr/share.

erlang-folsom.src: I: checking
erlang-folsom.src: W: spelling-error %description -l en_US realtime -> mealtime, real time, real-time
The value of this tag appears to be misspelled. Please double-check.

erlang-folsom.src: I: checking-url https://github.com/boundary/folsom (timeout 10 seconds)
erlang-folsom.src: W: invalid-url Source0: boundary-folsom-0.7.1-0-gc0019b3.tar.gz
The value should be a valid, public HTTP, HTTPS, or FTP URL.

erlang-folsom.spec: W: invalid-url Source0: boundary-folsom-0.7.1-0-gc0019b3.tar.gz
The value should be a valid, public HTTP, HTTPS, or FTP URL.

3 packages and 1 specfiles checked; 2 errors, 7 warnings.


Indeed, I cannot see any binary files. Should be "BuildArch: noarch".

The invalid source is ignorable because we speak about a Git snapshot here.
Comment 2 Peter Lemenkov 2012-10-07 11:01:17 EDT
(In reply to comment #1)

> erlang-folsom.i686: E: no-binary
> The package should be of the noarch architecture because it doesn't contain
> any binaries.

[...]

> erlang-folsom.i686: W: only-non-binary-in-usr-lib
> There are only non binary files in /usr/lib so they should be in /usr/share.

[...]

> erlang-folsom.x86_64: E: no-binary
> The package should be of the noarch architecture because it doesn't contain
> any binaries.
> 
> erlang-folsom.x86_64: W: only-non-binary-in-usr-lib
> There are only non binary files in /usr/lib so they should be in /usr/share.

[...]

> Indeed, I cannot see any binary files. Should be "BuildArch: noarch".

Unfortunately I skipped this tag intentionally. The problem is that Erlang by default requires that all libraries must be installed into %{_libdir}/erlang/lib which is arch-dependent. Thus all packages are has to be marked as such even if they doesn't actually contain any arch-dependent binaries.

I'm really sorry - I should have write Erlang Review but I didn't have much time for that. This is on my TODO list and I promise I'll pay my technical depth one day.

Technically speaking it's possible to explicitly set additional directories for Erlang VM to search for libraries in, but that's a huge and error-prone task (I plan to do it as well but I'm thinking in terms of Fedora 19 or even Fedora 20).
Comment 3 Mario Blättermann 2012-10-07 15:23:03 EDT
OK, I've just seen there are no noarch packages for Erlang modules. This explains some of the rpmlint warnings.


---------------------------------
key:

[+] OK
[.] OK, not applicable
[X] needs work
---------------------------------

[+] MUST: rpmlint must be run on the source rpm and all binary rpms the build produces. The output should be posted in the review.
[+] MUST: The package must be named according to the Package Naming Guidelines.
[+] MUST: The spec file name must match the base package %{name}, in the format %{name}.spec unless your package has an exemption.
[+] MUST: The package must meet the Packaging Guidelines.
[+] MUST: The package must be licensed with a Fedora approved license and meet the Licensing Guidelines.
[+] MUST: The License field in the package spec file must match the actual license.
    ASL 2.0
[+] MUST: If (and only if) the source package includes the text of the license(s) in its own file, then that file, containing the text of the license(s) for the package must be included in %doc.
[+] MUST: The spec file must be written in American English.
[+] MUST: The spec file for the package MUST be legible.
[+] MUST: The sources used to build the package must match the upstream source, as provided in the spec URL. Reviewers should use sha256sum for this task as it is used by the sources file once imported into git. If no upstream URL can be specified for this package, please see the Source URL Guidelines for how to deal with this.
    $ sha256sum *
    56acc088954d298f6416ffe9bed3725bbdd08ac31b6fb347d412320f17f9b4da  boundary-folsom-0.7.1-0-gc0019b3.tar.gz
    56acc088954d298f6416ffe9bed3725bbdd08ac31b6fb347d412320f17f9b4da  boundary-folsom-0.7.1-0-gc0019b3.tar.gz.orig

[+] MUST: The package MUST successfully compile and build into binary rpms on at least one primary architecture.
[.] MUST: If the package does not successfully compile, build or work on an architecture, then those architectures should be listed in the spec in ExcludeArch. Each architecture listed in ExcludeArch MUST have a bug filed in bugzilla, describing the reason that the package does not compile/build/work on that architecture. The bug number MUST be placed in a comment, next to the corresponding ExcludeArch line.
[+] MUST: All build dependencies must be listed in BuildRequires, except for any that are listed in the exceptions section of the Packaging Guidelines ; inclusion of those as BuildRequires is optional. Apply common sense.
[.] MUST: The spec file MUST handle locales properly. This is done by using the %find_lang macro. Using %{_datadir}/locale/* is strictly forbidden.
[.] MUST: Every binary RPM package (or subpackage) which stores shared library files (not just symlinks) in any of the dynamic linker's default paths, must call ldconfig in %post and %postun.
[.] MUST: Packages must NOT bundle copies of system libraries.
[.] MUST: If the package is designed to be relocatable, the packager must state this fact in the request for review, along with the rationalization for relocation of that specific package. Without this, use of Prefix: /usr is considered a blocker.
[+] MUST: A package must own all directories that it creates. If it does not create a directory that it uses, then it should require a package which does create that directory.
[+] MUST: A Fedora package must not list a file more than once in the spec file's %files listings. (Notable exception: license texts in specific situations)
[+] MUST: Permissions on files must be set properly. Executables should be set with executable permissions, for example.
[+] MUST: Each package must consistently use macros.
[+] MUST: The package must contain code, or permissable content.
[.] MUST: Large documentation files must go in a -doc subpackage. (The definition of large is left up to the packager's best judgement, but is not restricted to size. Large can refer to either size or quantity).
[+] MUST: If a package includes something as %doc, it must not affect the runtime of the application. To summarize: If it is in %doc, the program must run properly if it is not present.
[.] MUST: Static libraries must be in a -static package.
[.] MUST: Development files must be in a -devel package.
[.] MUST: In the vast majority of cases, devel packages must require the base package using a fully versioned dependency: Requires: %{name}%{?_isa} = %{version}-%{release}
[.] MUST: Packages must NOT contain any .la libtool archives, these must be removed in the spec if they are built.
[.] MUST: Packages containing GUI applications must include a %{name}.desktop file, and that file must be properly installed with desktop-file-install in the %install section. If you feel that your packaged GUI application does not need a .desktop file, you must put a comment in the spec file with your explanation.
[+] MUST: Packages must not own files or directories already owned by other packages. The rule of thumb here is that the first package to be installed should own the files or directories that other packages may rely upon. This means, for example, that no package in Fedora should ever share ownership with any of the files or directories owned by the filesystem or man package. If you feel that you have a good reason to own a file or directory that another package owns, then please present that at package review time.
[+] MUST: All filenames in rpm packages must be valid UTF-8.


[.] SHOULD: If the source package does not include license text(s) as a separate file from upstream, the packager SHOULD query upstream to include it.
[.] SHOULD: The description and summary sections in the package spec file should contain translations for supported Non-English languages, if available.
[+] SHOULD: The reviewer should test that the package builds in mock.
    See Koji build above (which uses Mock anyway).
[+] SHOULD: The package should compile and build into binary rpms on all supported architectures.
[.] SHOULD: The reviewer should test that the package functions as described. A package should not segfault instead of running, for example.
[+] SHOULD: If scriptlets are used, those scriptlets must be sane. This is vague, and left up to the reviewers judgement to determine sanity.
[.] SHOULD: Usually, subpackages other than devel should require the base package using a fully versioned dependency.
[.] SHOULD: The placement of pkgconfig(.pc) files depends on their usecase, and this is usually for development purposes, so should be placed in a -devel pkg. A reasonable exception is that the main pkg itself is a devel tool not installed in a user runtime, e.g. gcc or gdb.
[.] SHOULD: If the package has file dependencies outside of /etc, /bin, /sbin, /usr/bin, or /usr/sbin consider requiring the package which provides the file instead of the file itself.
[.] SHOULD: your package should contain man pages for binaries/scripts. If it doesn't, work with upstream to add them where they make sense.

----------------

PACKAGE APPROVED

----------------
Comment 4 Peter Lemenkov 2012-10-08 07:16:45 EDT
Thanks!

New Package SCM Request
=======================
Package Name: erlang-folsom
Short Description: Erlang-based metrics system
Owners: peter
Branches: f17 f18 el6
InitialCC:
Comment 5 Jason Tibbitts 2012-10-08 12:29:37 EDT
Git done (by process-git-requests).
Comment 6 Fedora Update System 2012-10-08 16:13:28 EDT
erlang-folsom-0.7.1-1.fc18 has been submitted as an update for Fedora 18.
https://admin.fedoraproject.org/updates/erlang-folsom-0.7.1-1.fc18
Comment 7 Fedora Update System 2012-10-08 16:13:38 EDT
erlang-folsom-0.7.1-1.el6 has been submitted as an update for Fedora EPEL 6.
https://admin.fedoraproject.org/updates/erlang-folsom-0.7.1-1.el6
Comment 8 Fedora Update System 2012-10-08 16:13:49 EDT
erlang-folsom-0.7.1-1.fc17 has been submitted as an update for Fedora 17.
https://admin.fedoraproject.org/updates/erlang-folsom-0.7.1-1.fc17
Comment 9 Fedora Update System 2012-10-08 19:53:52 EDT
erlang-folsom-0.7.1-1.fc18 has been pushed to the Fedora 18 testing repository.

Note You need to log in before you can comment on or make changes to this bug.